VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Adding"
   ClientHeight    =   1125
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   3495
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1125
   ScaleWidth      =   3495
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkComma 
      Caption         =   "Comma"
      Height          =   195
      Left            =   2340
      TabIndex        =   4
      Top             =   480
      Value           =   1  'Checked
      Width           =   1155
   End
   Begin VB.TextBox txtAnswer 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   60
      Locked          =   -1  'True
      TabIndex        =   3
      Top             =   780
      Width           =   3375
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add"
      Height          =   255
      Left            =   2340
      TabIndex        =   2
      Top             =   120
      Width           =   1095
   End
   Begin VB.TextBox txtNumber 
      Height          =   285
      Index           =   1
      Left            =   60
      TabIndex        =   1
      Top             =   480
      Width           =   2235
   End
   Begin VB.TextBox txtNumber 
      Height          =   285
      Index           =   0
      Left            =   60
      TabIndex        =   0
      Top             =   120
      Width           =   2235
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'**************************************************************************
'* Author:              Adam Wehmann
'* Created Using:       Microsoft Visual Basic 6.0 LE
'* Date of Creation:    Late June of 2002.
'* Last Modified:       June 30, 2002.
'**************************************************************************

Option Explicit

'**************************************************************************
'** Routine:            Numbers_Add
'** Description:        Performs addition on any two positive numbers.
'**                     Handles numbers larger than 2,147,483,647 which is
'**                     the max range for a Long data-type variable.
'** Parameters:         strNumber1 (String) - the first number.
'**                     strNumber2 (String) - the second number.
'**                     blComma (Boolean) - whether a non decimal answer
'**                         should have commas inserted every three
'**                         characters.
'** Return:             The total of the first and second numbers or
'**                     "" if there was a error.
'**************************************************************************
Private Function Numbers_Add(strNumber1 As String, strNumber2 As String, blComma As Boolean) As String
    Dim lngPosition As Long, lngAnswer As Long
    Dim lngDigit1 As Long, lngDigit2 As Long
    Dim lngRemainder As Long, strAnswer As String
    Dim lngPeriodPosition1 As Long, lngPeriodPosition2 As Long
    Dim lngDecimalLength1 As Long, lngDecimalLength2 As Long
    Dim blLastZero As Boolean, blOverride As Boolean
    If strNumber1 = "" Or strNumber2 = "" Then
        Numbers_Add = ""
        Exit Function
    End If
    '** Equalize the length of the numbers
    lngPeriodPosition1 = InStr(1, strNumber1, ".", vbTextCompare)
    lngPeriodPosition2 = InStr(1, strNumber2, ".", vbTextCompare)
    blOverride = False
    If lngPeriodPosition1 <> 0 Or lngPeriodPosition2 <> 0 Then
        blOverride = True
    End If
    If lngPeriodPosition1 <> 0 And lngPeriodPosition2 = 0 Then
        'A period was found in #1
        strNumber2 = strNumber2 & "."
        lngPeriodPosition2 = Len(strNumber2)
    ElseIf lngPeriodPosition1 = 0 And lngPeriodPosition2 <> 0 Then
        'A period was found in #2
        strNumber1 = strNumber1 & "."
        lngPeriodPosition1 = Len(strNumber1)
    End If
    If lngPeriodPosition1 <> 0 And lngPeriodPosition2 <> 0 Then
        lngDecimalLength1 = Len(strNumber1) - lngPeriodPosition1
        lngDecimalLength2 = Len(strNumber2) - lngPeriodPosition2
        If lngDecimalLength1 > lngDecimalLength2 Then
            strNumber2 = strNumber2 & String(lngDecimalLength1 - lngDecimalLength2, "0")
        ElseIf lngDecimalLength2 > lngDecimalLength1 Then
            strNumber1 = strNumber1 & String(lngDecimalLength2 - lngDecimalLength1, "0")
        End If
    End If
    If lngPeriodPosition1 = 0 Then lngPeriodPosition1 = Len(strNumber1)
    If lngPeriodPosition2 = 0 Then lngPeriodPosition2 = Len(strNumber2)
    'Make the length of each number the same by adding 0's to the beginning
    If lngPeriodPosition1 > lngPeriodPosition2 Then
        strNumber2 = String(lngPeriodPosition1 - lngPeriodPosition2, "0") & strNumber2
    ElseIf lngPeriodPosition2 > lngPeriodPosition1 Then
        strNumber1 = String(lngPeriodPosition2 - lngPeriodPosition1, "0") & strNumber1
    End If
    '** Start looping backwards through the digits
    lngPosition = Len(strNumber1)
    Do
        'Extract the digits
        If Mid(strNumber1, lngPosition, 1) = "." Or Mid(strNumber2, lngPosition, 1) = "." Then
            strAnswer = "." & strAnswer
        Else
            lngDigit1 = CLng(Mid(strNumber1, lngPosition, 1))
            lngDigit2 = CLng(Mid(strNumber2, lngPosition, 1))
            'Add the digits and any remainder from last loop around
            lngAnswer = lngDigit1 + lngDigit2 + lngRemainder
            'Check to see if we have a remainder for this new digit of our answer
            If lngAnswer > 9 Then
                'We have a remainder so extract the remainder and give the digit
                lngRemainder = CLng(Mid(Trim(Str(lngAnswer)), 1, 1))
                lngAnswer = CLng(Mid(Trim(Str(lngAnswer)), 2, 1))
            Else
                'No remainder
                lngRemainder = 0
            End If
            'Build our answer
            strAnswer = Trim(Str(lngAnswer)) & strAnswer
        End If
        lngPosition = lngPosition - 1
    Loop While lngPosition > 0
    'Add remainder to our answer
    strAnswer = Trim(Str(lngRemainder)) & strAnswer
    '** Remove leading zeros
    lngPosition = 1
    blLastZero = True
    Do
        If Mid(strAnswer, lngPosition, 1) = "0" And blLastZero = True Then
            Mid(strAnswer, lngPosition, 1) = " "
            blLastZero = True
        Else
            blLastZero = False
            Exit Do
        End If
        lngPosition = lngPosition + 1
    Loop While lngPosition <= Len(strAnswer)
    strAnswer = Trim(strAnswer)
    '** Remove trailing zeros
    lngPosition = Len(strAnswer)
    blLastZero = True
    Do
        If Mid(strAnswer, lngPosition, 1) = "0" And blLastZero = True Then
            Mid(strAnswer, lngPosition, 1) = ""
            blLastZero = True
        Else
            blLastZero = False
            Exit Do
        End If
        lngPosition = lngPosition - 1
    Loop While lngPosition >= 0
    strAnswer = Trim(strAnswer)
    '** Format our answer with commas
    If Len(strAnswer) > 3 And blComma And Not blOverride Then
        lngPosition = Len(strAnswer) - 3
        Do
            strAnswer = Mid(strAnswer, 1, lngPosition) & "," & Mid(strAnswer, lngPosition + 1, Len(strAnswer) - lngPosition)
            lngPosition = lngPosition - 3
        Loop While lngPosition > 0
    End If
    '** Output our answer
    Numbers_Add = strAnswer
End Function

Private Sub cmdAdd_Click()
    txtAnswer.Text = Numbers_Add(txtNumber(0).Text, txtNumber(1).Text, chkComma.Value)
End Sub

Private Sub txtNumber_KeyPress(Index As Integer, KeyAscii As Integer)
    If KeyAscii < Asc("0") Or KeyAscii > Asc("9") Then
        If KeyAscii <> 8 And KeyAscii <> Asc(".") Then
            KeyAscii = 0
        End If
    End If
End Sub
